#include <stdlib.h>
#ifdef OS2
#define INCL_DOSFILEMGR
#define INCL_BASE
#define INCL_DOSMISC
#endif

#include "duration.h"
#ifndef NON_UNIX
#include <algo.h>
#endif

Duration::Duration()
 : m_max(0)
#ifdef OS2
 , m_start(0)
#else
 , m_start()
#endif
{
}

void Duration::start()
{
  getTime(&m_start);
}

DUR_TYPE Duration::stop()
{
  TIMEVAL_TYPE tv;
  getTime(&tv);
  DUR_TYPE ret;
#ifdef OS2
  ret = (unsigned long)(tv - m_start) * 1000;
#else
#ifdef WIN32
  ret = (tv.time - m_start.time) * 1000
       + tv.millitm - m_start.millitm;
#else
  ret = (tv.tv_sec - m_start.tv_sec) * 1000000
       + tv.tv_usec - m_start.tv_usec;
#endif
#endif
  m_max = __max(m_max, ret);
  return ret;
}

bool Duration::getTime(TIMEVAL_TYPE *tv)
{
#ifdef OS2
  ULONG rc = DosQuerySysInfo(QSV_MS_COUNT, QSV_MS_COUNT, PVOID(tv), sizeof(tv));
  if(rc)
    return true;
#else
#ifdef WIN32
  _ftime(tv);
#else
  if (gettimeofday(tv, static_cast<struct timezone *>(NULL)) == -1)
    return true;
#endif
#endif
  return false;
}
